-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
  electrics.values['torso_tilt'] = 0
  electrics.values['torso_tilt_input'] = 0
  
  electrics.values['leg_upper_l'] = 0
  electrics.values['leg_upper_l_input'] = 0
  electrics.values['leg_lower_l'] = 0
  electrics.values['leg_lower_l_input'] = 0
  electrics.values['foot_l'] = 0
  electrics.values['foot_l_input'] = 0
  electrics.values['leg_upper_r'] = 0
  electrics.values['leg_upper_r_input'] = 0
  electrics.values['leg_lower_r'] = 0
  electrics.values['leg_lower_r_input'] = 0
  electrics.values['foot_r'] = 0
  electrics.values['foot_r_input'] = 0
end

local function updateGFX(dt) -- ms
  electrics.values['torso_tilt'] = math.min(1, math.max(-1.0, (electrics.values['torso_tilt'] + electrics.values['torso_tilt_input'] * dt * 1)))
  electrics.values['leg_upper_l'] = math.min(1, math.max(-1.0, (electrics.values['leg_upper_l'] + electrics.values['leg_upper_l_input'] * dt * 0.8)))
  electrics.values['leg_upper_r'] = math.min(1, math.max(-1.0, (electrics.values['leg_upper_r'] + electrics.values['leg_upper_r_input'] * dt * 0.8)))
  electrics.values['leg_lower_l'] = math.min(1, math.max(-1.0, (electrics.values['leg_lower_l'] + electrics.values['leg_lower_l_input'] * dt * 0.8)))
  electrics.values['leg_lower_r'] = math.min(1, math.max(-1.0, (electrics.values['leg_lower_r'] + electrics.values['leg_lower_r_input'] * dt * 0.8)))
  electrics.values['foot_l'] = math.min(1, math.max(-1.0, (electrics.values['foot_l'] + electrics.values['foot_l_input'] * dt * 0.8)))
  electrics.values['foot_r'] = math.min(1, math.max(-1.0, (electrics.values['foot_r'] + electrics.values['foot_r_input'] * dt * 0.8)))


end

local function liftBarrel(value)
  electrics.values.torso_tilt_input = value
end

local function barrelReset(value)
  electrics.values.torso_tilt_input = 0
end

local function kickR(value)
  electrics.values.leg_upper_l_input = -1*value
  electrics.values.leg_lower_l_input = -1*value
  electrics.values.foot_l_input = -1*value
  
  electrics.values.leg_upper_r_input = -1*value
  electrics.values.leg_lower_r_input = -1*value
  electrics.values.foot_r_input = -1*value
end

local function kickL(value)
  electrics.values.leg_upper_l_input = 1*value
  electrics.values.leg_lower_l_input = 1*value
  electrics.values.foot_l_input = 1*value
  
  electrics.values.leg_upper_r_input = 1*value
  electrics.values.leg_lower_r_input = 1*value
  electrics.values.foot_r_input = 1*value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.liftBarrel = liftBarrel
M.barrelReset = barrelReset
M.kickL = kickL
M.kickR = kickR

return M
